import { Type } from '@typespec/compiler';
export type EntityPropertyConfig = "parent" | "nested" | "ref" | "value" | "skip";
export declare const TypeConfig: TypeGraphConfig;
type PropsToDefine<T extends Type> = Exclude<keyof T, HiddenPropsType | keyof typeof CommonPropsConfig>;
type TypeConfig<T extends Type> = Record<PropsToDefine<T>, EntityPropertyConfig> | null;
type TypeGraphConfig = {
    [K in Type["kind"]]: TypeConfig<Extract<Type, {
        kind: K;
    }>>;
};
export declare const CommonPropsConfig: {
    namespace: string;
};
declare const HiddenProps: readonly ["entityKind", "kind", "name", "node", "symbol", "templateNode", "templateArguments", "templateMapper", "instantiationParameters", "decorators", "projectionBase", "projectionsByName", "projectionSource", "projector", "projections", "isFinished"];
type HiddenPropsType = (typeof HiddenProps)[number];
export declare const HiddenPropsSet: Set<"symbol" | "kind" | "entityKind" | "name" | "node" | "templateNode" | "templateArguments" | "templateMapper" | "instantiationParameters" | "decorators" | "projectionBase" | "projectionsByName" | "projectionSource" | "projector" | "projections" | "isFinished">;
export declare function getPropertyRendering<T extends Type, K extends keyof T>(type: T, key: K): EntityPropertyConfig;
export {};
//# sourceMappingURL=type-config.d.ts.map